<template>
    <div class="flex flex-col items-center w-full">
        <tags-header :tag="tag"></tags-header>
        <note-list @selected="handleNoteSelection" :notes="filteredNotes"></note-list>
    </div>
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { Watch } from 'vue-property-decorator'
import { State } from 'vuex-class'
import TagsHeader from '@/app/Editor/components/Tags/TagsHeader.vue'
import NoteList from '@/app/Editor/components/Notebook/NoteList.vue'
import { IRoot } from '@/store/types/root'
import { INotebook, INote } from '@/store/types/notebooks'
import { ITag } from '@/store/types/tags'
import { Route } from 'vue-router'

@Component({
    components: { TagsHeader, NoteList },
})
export default class TagNode extends Vue {
    // Lifecycles
    created() {
        if (!(this.allTags.length < 1)) {
            this.$store
                .dispatch('init')
                .then(() => {
                    this.$set(this.$data, 'tag', this.updateTag(this.$route))
                })
                .catch(e => {
                    throw new Error(e)
                })
        } else {
            this.$set(this.$data, 'tag', this.updateTag(this.$route))
        }
    }
    // Data

    tag: ITag | null = null

    // State

    @State((state: IRoot) => {
        return state.Notebooks.notebooks
    })
    allNotebooks!: INotebook[]

    @State((state: IRoot) => {
        return state.Tags.tags
    })
    allTags!: ITag[]

    // Computed

    get filteredNotes(): INote[] {
        if (!this.tag || this.allNotes.length < 1) return []
        const notes = this.allNotes.filter(note => {
            const tags = note.tags.filter(
                tag => tag.id === (this.tag as ITag).id
            )
            if (tags.length > 0) return true
            return false
        })
        return notes
    }

    get allNotes(): INote[] {
        if (!this.allNotebooks || this.allNotebooks.length < 1) return []

        const notes: INote[][] = this.allNotebooks
            .filter(notebook => notebook.notes)
            .map(notebook => notebook.notes as INote[])

        return notes
            .flat()
            .sort((a, b) => b.createdOn.getTime() - a.createdOn.getTime())
    }

    // Watch

    @Watch('$route')
    watchRoute(newRoute: Route, oldRoute: Route) {
        this.$set(this.$data, 'tag', this.updateTag(newRoute))
    }

    @Watch('allNotebooks')
    watchAllNotebooks() {
        this.$set(this.$data, 'tag', this.updateTag(this.$route))
    }

    @Watch('allTags')
    watchAllTags() {
        this.$set(this.$data, 'tag', this.updateTag(this.$route))
    }

    // Methods

    updateTag(route: Route): ITag | null {
        if (this.allTags) {
            const tag = this.allTags.filter(
                tag => tag.id === route.params.TagID
            )[0]
            return tag
        }
        return null
    }

    handleNoteSelection(note: INote) {
        if (note.id) {
            const url = `/notebook/${note.notebook.id}/${note.id}/`
            if (this.$route.fullPath !== url) this.$router.push(url)
        }
    }
}
</script>